#include "nmhttp.h"
#define ENCODING_IDENTITY 1
#define ENCODING_CHUNKED  2
#define DEBUG 0
void demand(int must, const char* message){
	if(!must){
		fprintf(stderr, "%s\n", message);
		exit(0);
	}
}
void stop(const char* message){
	fprintf(stderr, "%s\n", message);
	exit(0);
}
char* readLine(int sock, char* line=NULL){
	if(!line)line=new char[1024];
	char c;
	int length=0;
	while(read(sock, &c, 1) && (c!=10) && (c!=13)){ //accept both redmond and sensible endlines
		line[length++]=c;
	}
	if(c==13)read(sock, &c, 1); //remove redmond (13 10) endline
	line[length]=0;
	return line;
}
char* nmhttp(const char* string) {
	int sock, i=0;
	char c;
	hostent *he; // Used for DNS lookup
	sockaddr_in server; // inet addr stuff
	int addrsize = sizeof server; 
	char packet[1024]; // TCP packets max at 1024
	char retPacket[1024];
	char line[1024];
	char retString[100000];
	char* rretString; //real return string 
	char address[256]; // A variable to hold the servers' address
	const char* request; // request to server
	int port=80; // A variable for the port

	while ((string[i]!='/') && (string[i]!=0))i++;
	strncpy(address, string, i);
	request=string+i;
	i=0;
	if(DEBUG)printf("nmhttp for #%s#%s#\n", address, request);
	
	// ** step 1 Create the unconnected socket
	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) // Create the unconnected socket
		stop("Can't create socket"); 
	if(DEBUG)printf("socket created\n");

	// ** step 2: Set up the address 
	server.sin_family = AF_INET; 
	server.sin_port = htons((short)port); //set the port, from host to network byte order (in.h)
	server.sin_addr.s_addr = INADDR_ANY; 

	// ** step 3: 
	he = gethostbyname (address); //set the address (netdb.h)
	//printf ("he: h_name: %s\n", he->h_name); //h_addr_list[0] char* first addr
	//fprintf(stderr, "Attempting a connection with %s on port %d\n", address, port);
	//Is the ip/hostname working?
	if (!he) {
		//if ((server.sin_addr.s_addr = inet.addr (address)) == ADDR_NONE)
		stop("could not resolve name");
	} else {
		bcopy (he->h_addr, (struct in_addr *) &server.sin_addr, he->h_length); //copy bytes -> 
	}
	if(DEBUG)printf("name resolved\n");

	
	// ** step 4 connect to host
	if (connect (sock, (sockaddr *) &server, sizeof (server)) < 0)
		stop("Connection refused by remote host.");
	if(DEBUG)printf("connected to host\n");

	// ** step 5 send request
	//Create the packet
	//sprintf(packet, "POST /cgi-bin-marie/test HTTP/1.0\nContent-length: 12\n\nname=michael");
	//sprintf(packet, "GET %s HTTP/1.0\n\n", request);
	sprintf(packet, "GET %s HTTP/1.1\nHost: %s\n\n", request, address);
	//And send it
	write (sock, packet, strlen(packet));
	if(DEBUG)printf("package sent\n");

	// ** step 6: Read the answer
	if(DEBUG)setbuf(stdout,NULL);
	int httpVersion=0, httpSubVersion=0; //I know
	int code=0, chunkLength=0;
	char name[256];
	char encodingString[256]; int encoding=0;
	if(!readLine(sock, line))stop("no response");
	if(!sscanf(line, "HTTP/%d.%d %d %s", &httpVersion, &httpSubVersion, &code, name))stop("invalid response"); //magic line
	if(DEBUG)printf("version: %d.%d, code: %d\n", httpVersion, httpSubVersion, code);
	while(readLine(sock, line) && (line[0]!=0)){
		if(!strncmp("Transfer-Encoding:", line, 18)){
			sscanf(line, "Transfer-Encoding: %s", encodingString);
			if(!strcmp(encodingString, "chunked"))encoding=ENCODING_CHUNKED;
			else if(!strcmp(encodingString, "chunked"))encoding=ENCODING_CHUNKED;
			else stop("encoding not understood");
			if(DEBUG)printf("Transfer-Encoding: %s\n", encodingString);
		} else
		if(DEBUG)printf ("I DO NOT UNDERSTAND HEADER: %s\n", line);
	}
	//encoding=0;
	if(encoding==ENCODING_CHUNKED){
		do{
			if(!readLine(sock, line))stop("could not read chunk size");
			if(!sscanf(line, "%x", &chunkLength))stop("could not parse chunk size");
			for(int j=0; j<chunkLength; j++){ 
				read(sock, &c, 1);
				retString[i++]=c;
				if(DEBUG)printf("%6d bytes read\r", i);
			}
			if(!readLine(sock, line))stop("no endline after chunk"); //remove endline after chunk
		}while(chunkLength); //untill a chunk with length 0 is encountered (last chunk)
	} else {
		while(read(sock, &c, 1)) { 
			retString[i++]=c;
			if(DEBUG)printf("%6d bytes read\r", i);
		} 
	}
	if(DEBUG)printf("\nanswer read\n");
	close (sock); // Close the connection

	rretString=(char*)calloc(sizeof(char), i+1); //copy to an exact fitting string
	bcopy (retString, rretString, i+1);
	rretString[i]=0; //nice c string
	return rretString;
}
